
LeetCodeCampsDay41动态规划part08
股票问题从入门到通关
121. 买卖股票的最佳时机
https://leetcode.cn/problems/best-time-to-buy-and-sell-stock/
给定一个数组 prices ,它的第 i 个元素 prices[i] 表示一支给定股票第 i 天的价格。
你只能选择 某一天 买入这只股票,并选择在 未来的某一个不同的日子 卖出该股票。设计一个算法来计算你所能获取的最大利润。
返回你可以从这笔交易中获取的最大利润。如果你不能获取任何利润,返回 0 。
示例 1:
输入:[7,1,5,3,6,4]
输出:5
解释:在第 2 天(股票价格 = 1)的时候买入,在第 5 天(股票价格 = 6)的时候卖出,最大利润 = 6-1 = 5 。
注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格;同时,你不能在买入前卖出股票。示例 2:
输入:prices = [7,6,4,3,1]
输出:0
解释:在这种情况下, 没有交易完成, 所以最大利润为 0。提示:
1 <= prices.length <= 1050 <= prices[i] <= 104
动态规划思路
- dp数组含义
dp[i][0]表示第i天持有股票所得最多现金
dp[i][1]表示第i天没有股票所得最多现金
- 递推公式
如果第i天持有股票,则需要判断持有的股票是否有更低的买入价格(其中-prices[i]就是成本价格dp[i][0])
dp[i][0] = max(dp[i - 1][0], -prices[i])
- dp[i - 1][0]是之前买了股票后剩下的钱,-prices[i]是买了当日股票剩下的钱
如果第i天没有股票,则那天要卖股票
dp[i][1] = max(dp[i - 1][1], dp[i - 1][0] + prices[i])
- dp[i - 1][1] 是之前卖股票更挣钱,而dp[i - 1][0] + prices[i] 今天的行情不错,股票卖掉,血赚prices[i]块钱, dp[i-1][0]是我用低价买入花的钱(这里将dp[i - 1][0]换成dp[i][0]也可以,并且可能更好理解)
- 初始化
仅将第0天的持有股票初始化为-prices[0],表示无论如何一定要买一支股票
- 遍历顺序
遍历顺序,i遍历卖出时间(范围1到n)
动态规划代码
class Solution:
def maxProfit(self, prices: List[int]) -> int:
L = len(prices)
dp = [[0] * (2) for _ in range(L)]
dp[0][0] = -prices[0]
print(dp)
for i in range(1, L):
dp[i][0] = max(dp[i - 1][0], -prices[i])
# 这里将dp[i - 1][0] + prices[i]改成dp[i][0]也可以,可以把dp[i][0]理解成当天的投入成本、prices[i]是当天卖价,dp[i][1]是当天利润
# 为了将当天利润最大化,比较前一天利润与当天利润,取最大值
dp[i][1] = max(dp[i - 1][1], dp[i][0] + prices[i])
print(dp)
return dp[-1][-1]122. 买卖股票的最佳时机 II
https://leetcode.cn/problems/best-time-to-buy-and-sell-stock-ii/
给你一个整数数组 prices ,其中 prices[i] 表示某支股票第 i 天的价格。
在每一天,你可以决定是否购买和/或出售股票。你在任何时候 最多 只能持有 一股 股票。你也可以先购买,然后在 同一天 出售。
返回 你能获得的 最大 利润 。
示例 1:
输入:prices = [7,1,5,3,6,4]
输出:7
解释:在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5 - 1 = 4。
随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6 - 3 = 3。
最大总利润为 4 + 3 = 7 。示例 2:
输入:prices = [1,2,3,4,5]
输出:4
解释:在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5 - 1 = 4。
最大总利润为 4 。示例 3:
输入:prices = [7,6,4,3,1]
输出:0
解释:在这种情况下, 交易无法获得正利润,所以不参与交易可以获得最大利润,最大利润为 0。提示:
1 <= prices.length <= 3 * 1040 <= prices[i] <= 104
动态规划思路一
需要有双指针,一个j指向某支股票买入天数,另一个i遍历所有售出天数;
动态规划代码一
通过 200 / 202 个通过的测试用例
超时了
class Solution:
def maxProfit(self, prices: List[int]) -> int:
# dp[i] = max(dp[i - 1], dp[j] + prices[i] - prices[j])
L = len(prices)
dp = [0] * (L + 1)
for i in range(1, L):
for j in range(i):
dp[i] = max(dp[i - 1], dp[j] + prices[i] - prices[j])
print(dp)
return dp[-2]动态规划思路二
本题和[121. 买卖股票的最佳时机的唯一区别是本题股票可以买卖多次了(注意只有一只股票,所以再次购买前要出售掉之前的股票)
在动规五部曲中,这个区别主要是体现在递推公式上,其他都和121. 买卖股票的最佳时机一样的。
- dp数组含义
dp[i][0]表示第i天持有股票所得最多现金
dp[i][1]表示第i天没有股票所得最多现金
- 递推公式
如果第i天持有股票,则需要判断持有的股票是否有更低的买入价格(其中-prices[i]就是成本价格dp[i][0])
dp[i][0] = max(dp[i - 1][0], dp[i - 1][1] - prices[i])
- dp[i - 1][0]是之前买了股票后剩下的钱,dp[i - 1][1] - prices[i]是前一次卖了股票后剩下的钱,去买当日股票剩下的钱,还是看哪次剩下的钱更多
如果第i天没有股票,则那天要卖股票
dp[i][1] = max(dp[i - 1][1], dp[i - 1][0] + prices[i])
- dp[i - 1][1] 是之前卖股票更挣钱,而dp[i - 1][0] + prices[i] 今天的行情不错,股票卖掉,血赚prices[i]块钱, dp[i-1][0]是我用低价买入花的钱(这里将dp[i - 1][0]换成dp[i][0]也可以,并且可能更好理解)
- 初始化
仅将第0天的持有股票初始化为-prices[0],表示无论如何一定要买一支股票
dp[0][0] = -prices[0]
dp[0][1] = 0 (表示第一天剩下0元)
- 遍历顺序
遍历顺序,i遍历卖出时间(范围1到n)
动态规划代码二
class Solution:
def maxProfit(self, prices: List[int]) -> int:
L = len(prices)
dp = [[0] * (2) for _ in range(L)]
dp[0][0] = -prices[0]
for i in range(1, L):
# 因为一只股票可以买卖多次,所以当第i天买入股票的时候,所持有的现金可能有之前买卖过的利润。
# 那么第i天持有股票即dp[i][0],如果是第i天买入股票,所得现金就是 "昨天不持有股票的所得现金 减去 今天的股票价格" 即:dp[i - 1][1] - prices[i]。
# dp[i - 1][1]理解成前一天卖出股票后剩下的所有钱
dp[i][0] = max(dp[i - 1][0], dp[i - 1][1] - prices[i])
# 这里的dp[i][0]理解成第i天买入股票后剩下的所有钱
# 使用dp[i - 1][0]也是可以的
dp[i][1] = max(dp[i - 1][1], dp[i][0] + prices[i])
return dp[-1][-1]把这里的
dp[i][0] = max(dp[i - 1][0], dp[i - 1][1] - prices[i])修改成
dp[i][0] = max(dp[i - 1][0], 0 - prices[i])则变成了只能一只股票只买卖一次的情况
123. 买卖股票的最佳时机 III
https://leetcode.cn/problems/best-time-to-buy-and-sell-stock-iii/
给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。
**注意:**你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入:prices = [3,3,5,0,0,3,1,4]
输出:6
解释:在第 4 天(股票价格 = 0)的时候买入,在第 6 天(股票价格 = 3)的时候卖出,这笔交易所能获得利润 = 3-0 = 3 。
随后,在第 7 天(股票价格 = 1)的时候买入,在第 8 天 (股票价格 = 4)的时候卖出,这笔交易所能获得利润 = 4-1 = 3 。示例 2:
输入:prices = [1,2,3,4,5]
输出:4
解释:在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。
因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。示例 3:
输入:prices = [7,6,4,3,1]
输出:0
解释:在这个情况下, 没有交易完成, 所以最大利润为 0。示例 4:
输入:prices = [1]
输出:0提示:
1 <= prices.length <= 1050 <= prices[i] <= 105
动态规划思路
本题和[121. 买卖股票的最佳时机的唯一区别是本题股票可以最多操作两次,指可以买两支不同的股票
在动规五部曲中,这个区别主要是体现在递推公式上
- dp数组含义
dp[i][0]表示第i天第一次操作持有股票所得最多现金,表示第i天才开始第一次操作,在此之前的天不进行任何操作!
dp[i][1]表示第i天第一次操作没有股票所得最多现金
dp[i][2]表示第i天第二次操作持有股票所得最多现金
dp[i][3]表示第i天第二次操作没有股票所得最多现金
- 递推公式
第i天,第一次买入,则需要判断持有的股票是否有更低的买入价格(其中-prices[i]就是成本价格dp[i][0])
dp[i][0] = max(dp[i - 1][1], - prices[i])
- dp[i - 1][0]是之前买了股票后剩下的钱,- prices[i]是买当日股票剩下的钱,不管是第几天,只要是第一次操作,初始的钱一定为0啊
第i天,第一次卖出
dp[i][1] = max(dp[i - 1][2], dp[i][0] + prices[i])
- dp[i - 1][2] 是之前的i-1天卖股票挣的钱
- dp[i - 1][1] + prices[i] 表示今天的行情不错,股票卖掉,血赚prices[i]块钱, dp[i-1][0]是我用低价买入花的钱(这里将dp[i - 1][0]换成dp[i][0]也可以,并且可能更好理解,表示当天买了股票后剩下的钱)
第i天,第二次买入,
dp[i][2] = max(dp[i - 1][3], dp[i - 1][1] - prices[i])
- dp[i - 1][3]是之前买了股票后剩下的钱
- dp[i - 1][1] - prices[i]是买当日股票剩下的钱,其中dp[i - 1][1]为第i-1天的第二次操作后剩下的钱
第i天,第二次卖出
dp[i][3] = max(dp[i - 1][4], dp[i][2] + prices[i])
- dp[i - 1][4] 是之前的i-1天第二次操作后挣的钱
- dp[i - 1][2] + prices[i] 表示今天的行情不错,股票卖掉,血赚prices[i]块钱, dp[i-1][2]是我用低价买入花的钱(这里将dp[i - 1][2]换成dp[i][2]也可以,并且可能更好理解,表示当天买了股票后剩下的钱)
- 初始化
仅将第0天的持有股票初始化为-prices[0],表示无论如何一定要买一支股票
- 遍历顺序
遍历顺序,i遍历卖出时间(范围1到n)
动态规划代码
class Solution:
def maxProfit(self, prices: List[int]) -> int:
# 和前两题目相比,本题一共可以买、卖再次
# 所以dp数组的状态则不是只有一次买入&卖出两种状态
# 而dp数组应该有4种状态
# 1 第一次买入 2、第一次卖出 3、 第二次买入 4、 第二次不卖出
# 而dp[i][j] 的i表示第i天而j表示上面提到的四种状态,而dp[i][j]表示第i天第j状态的最大现金
dp = [[0] * 4 for _ in range(len(prices))]
# 递推公式
# 第i天第一次买入,
# dp[i][0] = max(dp[i - 1][0], - prices[i])
# 第i天第一次卖出,
# dp[i][1] = max(dp[i - 1][1], dp[i][0] + prices[i])
# 第i天第二次买入
# dp[i][2] = max(dp[i - 1][2], dp[i - 1][1] - prices[i])
# 第i天第二次卖出
# dp[i][3] = max(dp[i - 1][3], dp[i][2] + prices[i])
# dp初始化
# dp[0][0]为-prices[0],dp[0][1]为0,dp[0][2]为-prices[0],dp[0][3]为0,
# 这里的-prices也可以认为刚开始剩下的钱是0,
dp[0][0] = dp[0][2] = -prices[0]
for i in range(1, len(prices)):
# 表示是买入状态
dp[i][0] = max(dp[i - 1][0], - prices[i])
# 表示为卖出状态
dp[i][1] = max(dp[i - 1][1], dp[i][0] + prices[i])
#
dp[i][2] = max(dp[i - 1][2], dp[i - 1][1] - prices[i])
dp[i][3] = max(dp[i - 1][3], dp[i][2] + prices[i])
return dp[-1][-1]188. 买卖股票的最佳时机 IV
https://leetcode.cn/problems/best-time-to-buy-and-sell-stock-iv/
给你一个整数数组 prices 和一个整数 k ,其中 prices[i] 是某支给定的股票在第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你最多可以完成 k 笔交易。也就是说,你最多可以买 k 次,卖 k 次。
**注意:**你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入:k = 2, prices = [2,4,1]
输出:2
解释:在第 1 天 (股票价格 = 2) 的时候买入,在第 2 天 (股票价格 = 4) 的时候卖出,这笔交易所能获得利润 = 4-2 = 2 。示例 2:
输入:k = 2, prices = [3,2,6,5,0,3]
输出:7
解释:在第 2 天 (股票价格 = 2) 的时候买入,在第 3 天 (股票价格 = 6) 的时候卖出, 这笔交易所能获得利润 = 6-2 = 4 。
随后,在第 5 天 (股票价格 = 0) 的时候买入,在第 6 天 (股票价格 = 3) 的时候卖出, 这笔交易所能获得利润 = 3-0 = 3 。提示:
1 <= k <= 1001 <= prices.length <= 10000 <= prices[i] <= 1000
动态规划思路
在动规五部曲中,这个区别主要是体现在递推公式上
- dp数组含义
dp[i][0]表示第i天第一次操作持有股票所得最多现金,表示第i天才开始第一次操作,在此之前的天不进行任何操作!
dp[i][1]表示第i天第一次操作没有股票所得最多现金
dp[i][2]表示第i天第二次操作持有股票所得最多现金
dp[i][3]表示第i天第二次操作没有股票所得最多现金
dp[i][4]表示第i天第三次操作持有股票所得最多现金
……
数组开的大小为dp[len(prices)][ 2 * k], 因为每次操作都有买入与卖出两种类型
- 递推公式
第i天,第一次考虑买入
dp[i][j] = max(dp[i - 1][j], - prices[i])
- dp[i - 1][j]是上一次买了股票后剩下的钱
- -prices[i]是买当日股票剩下的钱,不管是第几天,如果是第一次买入,则初始资金一定为0
- 只要比较下两者剩下的钱,就知道第i天是否适合作为第一次买入
第i天,非第一次考虑买入
dp[i][j] = max(dp[i - 1][j], dp[i - 1][j - 1] - prices[i])
- dp[i - 1][0]是上一次买了股票后剩下的钱
- dp[i - 1][j - 1] - prices[i]是买当日股票剩下的钱,如果不是第一次买入,则初始资金为上一次卖出后的钱dp[i - 1][j - 1(i-1为上一次,j-1为卖出)
- 只要比较下两者剩下的钱,就知道第i天是否适合作为非第一次买入
第i天,考虑卖出
dp[i][j] = max(dp[i - 1][j], dp[i][j - 1] + prices[i])
- dp[i-1][j]为上一次卖出剩下的钱
- dp[i][j - 1] + prices[i]为本次卖出剩下的钱,这里换成dp[i - 1][j - 1] 也是正确的,则表示用上一次买入后剩下的钱加上这次卖出,得到了第i天第j次卖出后剩下的钱
- 只要比较下两者剩下的钱,就知道第i天是否适合卖出,如果不卖出则继续保持dp[i-1][j]的金额
- 初始化
仅将第0天的持有股票初始化为-prices[0],表示无论如何一定要买一支股票
- 遍历顺序
遍历顺序,i遍历卖出时间(范围1到n),j遍历操作的次数(范围从0到2k-1)
如果j是偶数则是买入操作,再判断是否是第一次买入
如果j是奇数则是卖出操作,
动态规划代码
class Solution:
def maxProfit(self, k: int, prices: List[int]) -> int:
L = len(prices)
dp = [[0] * 2 * k for _ in range(L)]
for i in range(2 * k):
if i % 2 == 0:
dp[0][i] = -prices[0]
for i in range(1, L):
for j in range(2 * k):
# 买入操作
if j % 2 == 0:
# 如果是第一次买入,则初始资金一定为0
if j == 0:
# dp[i-1][j]为上一次买入剩下的钱,-prices[i]为本次买入剩下的钱
dp[i][j] = max(dp[i - 1][j], -prices[i])
# 如果不是第一次买入,则初始资金为上一次卖出后的钱(i-1为上一次,j-1为卖出)
else:
# dp[i-1][j]为上一次买入剩下的钱,dp[i - 1][j - 1]-prices[i]为本次买入剩下的钱
dp[i][j] = max(dp[i - 1][j], dp[i - 1][j - 1] - prices[i])
# 卖出操作
else:
# dp[i-1][j]为上一次卖出剩下的钱, dp[i][j - 1] + prices[i]为本次卖出剩下的钱
dp[i][j] = max(dp[i - 1][j], dp[i][j - 1] + prices[i])
print(dp)
return dp[-1][-1]- 文章作者:
- Lthero博客
- 版权声明:
- 本博客所有文章除特别声明外,均采用CC BY-NC-SA 4.0许可协议。转载请注明来自 Lthero博客!



